Attribute VB_Name = "mGIF"
Option Explicit
Option Compare Text

'#Const DebugGIF = True

'ļͷϢ
'typedef struct gifheader
'   {
'      BYTE bySignature[3];
'      BYTE byVersion[3];
'   }  GIFHEADER;
Public Type gifheader
    bySignature(0 To 3 - 1) As Byte
    byVersion(0 To 3 - 1) As Byte
End Type

'߼Ļ
'typedef struct gifscrdesc
'   {
'      WORD wWidth;
'      WORD wDepth;
'      struct globalflag
'         {
'            BYTE PalBits   : 3;
'            BYTE SortFlag  : 1;
'            BYTE ColorRes  : 3;
'            BYTE GlobalPal : 1;
'         }  GlobalFlag;
'      BYTE byBackground;
'      BYTE byAspect;
'   }  GIFSCRDESC;
Public Type gifscrdesc
    wWidth As Integer
    wDepth As Integer
    GlobalFlag As Byte
    byBackground As Byte
    byAspect As Byte
End Type
Public Const GlobalFlag_PalBits As Byte = &H7
Public Const GlobalFlag_SortFlag As Byte = &H8
Public Const GlobalFlag_ColorRes As Byte = &H70
Public Const GlobalFlag_GlobalPal As Byte = &H80


'ͼָ
Public Const GIF_ImageSeparator As Byte = &H2C

'ͼ
'typedef struct gifimage
'   {
'      WORD wLeft;
'      WORD wTop;
'      WORD wWidth;
'      WORD wDepth;
'      struct localflag
'         {
'            BYTE PalBits   : 3;
'            BYTE Reserved  : 2;
'            BYTE SortFlag  : 1;
'            BYTE Interlace : 1;
'            BYTE LocalPal  : 1;
'         }  LocalFlag;
'   }  GIFIMAGE;
Public Type gifimage
    wLeft     As Integer
    wTop      As Integer
    wWidth    As Integer
    wDepth    As Integer
    LocalFlag As Byte
End Type
Public Const LocalFlag_PalBits As Byte = &H7
Public Const LocalFlag_Reserved As Byte = &H18
Public Const LocalFlag_SortFlag As Byte = &H20
Public Const LocalFlag_Interlace As Byte = &H40
Public Const LocalFlag_LocalPal As Byte = &H80


'
Public Const GIF_Extension As Byte = &H21

'
Public Const GIF_gifcontrol As Byte = &HF9
'typedef struct gifcontrol
'   {
'      BYTE byBlockSize;
'      struct flag
'         {
'            BYTE Transparency   : 1;
'            BYTE UserInput      : 1;
'            BYTE DisposalMethod : 3;
'            BYTE Reserved       : 3;
'         }  Flag;
'      WORD wDelayTime;
'      BYTE byTransparencyIndex;
'      BYTE byTerminator;
'   }  GIFCONTROL;
Public Type gifcontrol
    byBlockSize As Byte '=4
    flag As Byte
    wDelayTime As Integer
    byTransparencyIndex As Byte
    byTerminator As Byte
End Type

'˵
Public Const GIF_gifplaintext As Byte = &H1
'typedef struct gifplaintext
'   {
'      BYTE byBlockSize;
'      WORD wTextGridLeft;
'      WORD wTextGridTop;
'      WORD wTextGridWidth;
'      WORD wTextGridDepth;
'      BYTE byCharCellWidth;
'      BYTE byCharCellDepth;
'      BYTE byForeColorIndex;
'      BYTE byBackColorIndex;
'   }  GIFPLAINTEXT;
Public Type gifplaintext
    byBlockSize As Byte '=12
    wTextGridLeft As Integer
    wTextGridTop As Integer
    wTextGridWidth As Integer
    wTextGridDepth As Integer
    byCharCellWidth As Byte
    byCharCellDepth As Byte
    byForeColorIndex As Byte
    byBackColorIndex As Byte
End Type

'ע
Public Const GIF_Comment As Byte = &HFE

'Ӧó
Public Const GIF_gifapplication As Byte = &HFF
'typedef struct gifapplication
'   {
'      BYTE byBlockSize;
'      BYTE byIdentifier[8];
'      BYTE byAuthentication[3];
'   }  GIFAPPLICATION;
Public Type gifapplication
    byBlockSize As Byte '=11
    byIdentifier(0 To 8 - 1) As Byte
    byAuthentication(0 To 3 - 1) As Byte
End Type

'ļβ
Public Const Gif_Terminator As Byte = &H3B


Public Const MaxCodeBits As Long = 12&



'////////////////////////////////////////////////
'## API #########################################
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors(0 To &HFF) As RGBQUAD
End Type

Private Const BI_RGB As Long = 0&


Private Declare Function GetObject Lib "gdi32.dll" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type


Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long


Private Declare Function GetDIBits Lib "gdi32.dll" (ByVal hDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As Any, ByVal wUsage As Long) As Long
Private Const DIB_RGB_COLORS As Long = 0
Private Const DIB_PAL_COLORS As Long = 1


Private Declare Function SetDIBitsToDevice Lib "gdi32.dll" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal dX As Long, ByVal dY As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As Any, ByVal wUsage As Long) As Long


'////////////////////////////////////////////////
'################################################
'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

Private m_Inited As Boolean


Private BitAndMask(0 To 31) As Long
Private BitsMask(0 To 32) As Long
Private IncTable(0 To 4) As Long 'ʽ洢ʱÿӵ
Private BgnTable(0 To 4) As Long 'ʽ洢ʱʼ

Public Property Get Inited() As Boolean
    Inited = m_Inited
End Property

Public Sub Init()
    If m_Inited Then Exit Sub
    
    Dim I As Long
    
    For I = 0 To 30
        BitAndMask(I) = 2& ^ I
    Next I
    BitAndMask(31) = &H80000000
    
    For I = 0 To 31
        BitsMask(I) = 2& ^ I - 1
    Next I
    BitsMask(31) = &H7FFFFFFF
    BitsMask(32) = -1 '&HFFFFFFFF
    
    IncTable(0) = 8
    IncTable(1) = 8
    IncTable(2) = 4
    IncTable(3) = 2
    IncTable(4) = 0
    
    BgnTable(0) = 0
    BgnTable(1) = 4
    BgnTable(2) = 2
    BgnTable(3) = 1
    BgnTable(4) = 0
    
    m_Inited = True
    
End Sub

'GIF_LZW
'lpBI:ָBitMapInfoHeaderָ
'lpBits:ָDIBλͼݵָ
'hFile:ҪļľVBģ
'ImgInfo:GIFϢ
'gifsd:ҪһЩȫϢ
Public Function EncodeGIF_LZW(ByVal lpBI As Long, ByVal lpBits As Long, ByVal hFile As Integer, ByRef ImgInfo As gifimage, ByRef gifsd As gifscrdesc) As Boolean
    If m_Inited = False Then Init
    If (lpBI = 0) Or (lpBits = 0) Then Exit Function
    
    Dim I As Long
    
    'ȡBitmapInfoݲ֧BITMAPV4HEADERBITMAPV5HEADER
    Dim BI As BITMAPINFO
    If IsBadReadPtr(ByVal lpBI, 4) Then Exit Function
    Call CopyMemory(I, ByVal lpBI, 4)
    Select Case I
    Case 40 'BITMAPINFOHEADER
    'Case 40 'BITMAPV4HEADER
    'Case 40 'BITMAPV5HEADER
    Case Else
        Exit Function
    End Select
    If IsBadReadPtr(ByVal lpBI, I) Then Exit Function
    Call CopyMemory(BI.bmiHeader, ByVal lpBI, I)
    
    'DIBλͼϢݲ֧1λ4λ
    Dim DataBits As Long
    If BI.bmiHeader.biWidth < 0 Or BI.bmiHeader.biHeight < 0 Then Exit Function
    DataBits = BI.bmiHeader.biBitCount
    Select Case DataBits
    'Case 1
    'Case 4
    Case 8
    Case Else
        Exit Function
    End Select
    If BI.bmiHeader.biCompression <> BI_RGB Then Exit Function
    
    
    'ȡɫ
    I = 2 ^ DataBits
    If BI.bmiHeader.biClrUsed Then I = BI.bmiHeader.biClrUsed
    I = I * 4
    If IsBadReadPtr(ByVal CLng(lpBI + BI.bmiHeader.biSize), I) Then Exit Function
    Call CopyMemory(BI.bmiColors(0), ByVal CLng(lpBI + BI.bmiHeader.biSize), I)
    
    'DIBλͼݵڴ
    Dim LineBytes As Long
    With BI.bmiHeader
        LineBytes = ((.biWidth * .biBitCount + 31&) And &HFFFFFFE0) \ 8
        .biSizeImage = LineBytes * .biHeight
        If IsBadReadPtr(ByVal lpBits, .biSizeImage) Then Exit Function
    End With
    
    'ʼImgInfo
    With ImgInfo
        .wWidth = BI.bmiHeader.biWidth
        .wDepth = BI.bmiHeader.biHeight
        'X'ݲֽ֧
        'If .LocalFlag And LocalFlag_Interlace Then Exit Function
        
        Put hFile, , ImgInfo
        
        'дɫ
        If (.LocalFlag And LocalFlag_LocalPal) Or (gifsd.GlobalFlag And GlobalFlag_GlobalPal) = 0 Then
            .LocalFlag = (DataBits - 1) Or (.LocalFlag And Not LocalFlag_PalBits) Or LocalFlag_LocalPal
            For I = 0 To (2 ^ DataBits) - 1
                Put hFile, , BI.bmiColors(I).rgbRed
                Put hFile, , BI.bmiColors(I).rgbGreen
                Put hFile, , BI.bmiColors(I).rgbBlue
            Next I
        End If
        
    End With
    
    'дLZW_MinCodeLen
    Dim LZW_MinCodeLen As Byte
    LZW_MinCodeLen = DataBits
    If LZW_MinCodeLen = 1 Then LZW_MinCodeLen = 2 'ΪLZW_CLEARLZW_EOIռλ
    Put hFile, , LZW_MinCodeLen
    
    
    '== ʽʼ ============================
    Dim NextNode(0 To &H1000) As Integer
    Dim SubNode(0 To &H1000) As Integer
    Dim StrAdd(0 To &H1000) As Byte
    Dim TableSize As Long
    Dim TableMaxSize As Long
    Dim CurBits As Long
    Dim LZW_CLEAR As Integer
    Dim LZW_EOI As Integer
    Dim OldCode As Integer
    Dim CurByte As Byte
    Dim TempIdx As Integer
    Dim f As Boolean
    Dim TempCode As Long
    Dim LeftBits As Long
    Dim SubBlock() As Byte
    Dim BlockSize As Byte
    Dim byPass As Byte
    
    ReDim SubBlock(0 To &HFF)
    SubBlock(0) = &HFF
    
    #If DebugGIF Then
        Dim hF As Integer
        hF = FreeFile()
        Open "c:\DebugGIF_En.log" For Output As #hF
    #End If
    
    LZW_CLEAR = 2 ^ DataBits
    LZW_EOI = LZW_CLEAR + 1
    CurBits = LZW_MinCodeLen + 1
    GoSub InitStrTable
    
    
    'ģָ
    Dim pByte() As Byte
    Dim pBytePtr() As Long
    Dim SApByte As SAFEARRAY1D
    Dim SApBytePtr As SAFEARRAY1D
    With SApByte
        .cDims = 1
        .fFeatures = 0
        .cbElements = 1
        .cLocks = 0
        .pvData = lpBI
        .Bounds(0).lLbound = 0
        .Bounds(0).cElements = 1
    End With
    With SApBytePtr
        .cDims = 1
        .fFeatures = 0
        .cbElements = 4
        .cLocks = 0
        .pvData = VarPtr(SApByte.pvData)
        .Bounds(0).lLbound = 0
        .Bounds(0).cElements = 1
    End With
    CopyMemory ByVal VarPtrArray(pByte), VarPtr(SApByte), 4
    CopyMemory ByVal VarPtrArray(pBytePtr), VarPtr(SApBytePtr), 4
    
    
    byPass = 0
    Dim LinePtr As Long
    Dim X As Long, Y As Long
    Y = 0
    X = 0
    LinePtr = lpBits + (BI.bmiHeader.biHeight - 1) * LineBytes  'DIB洢
    pBytePtr(0) = LinePtr
    Select Case DataBits
    Case 1
    Case 4
    Case 8
        OldCode = pByte(0)
        pBytePtr(0) = pBytePtr(0) + 1
        X = X + 1
        Do While Y < BI.bmiHeader.biHeight
            CurByte = pByte(0)
            f = SubNode(OldCode)
            If f Then
                TempIdx = SubNode(OldCode)
                Do Until StrAdd(TempIdx) = CurByte
                    If NextNode(TempIdx) Then
                        TempIdx = NextNode(TempIdx)
                    Else
                        NextNode(TempIdx) = TableSize
                        f = False
                        Exit Do
                    End If
                Loop
            Else
                SubNode(OldCode) = TableSize
            End If
            
            If f Then
                OldCode = TempIdx
            Else
                GoSub WriteCode
                
                StrAdd(TableSize) = CurByte
                TableSize = TableSize + 1
                If TableSize > TableMaxSize Then
                    If CurBits < MaxCodeBits Then
                        CurBits = CurBits + 1
                        TableMaxSize = TableMaxSize * 2 'tablemaxsize<<=1
                    Else
                        GoSub InitStrTable
                    End If
                End If
                OldCode = CurByte
                
            End If
            
            X = X + 1
            pBytePtr(0) = pBytePtr(0) + 1
            
            If X >= BI.bmiHeader.biWidth Then
                If ImgInfo.LocalFlag And LocalFlag_Interlace Then
                    Y = Y + IncTable(byPass)
                    If Y >= BI.bmiHeader.biHeight Then
                        byPass = byPass + 1
                        Y = BgnTable(byPass)
                        If IncTable(byPass) = 0 Then Exit Do
                    End If
                    pBytePtr(0) = lpBits + (BI.bmiHeader.biHeight - 1 - Y) * LineBytes 'DIB洢
                Else
                    Y = Y + 1
                    LinePtr = LinePtr - LineBytes
                    pBytePtr(0) = LinePtr
                End If
                X = 0
            End If
            
        Loop
        
    End Select
    GoSub WriteCode
    
    OldCode = LZW_EOI
    GoSub WriteCode
    
    If LeftBits Then
        LeftBits = 8
        GoSub ShiftBit
    End If
    If BlockSize Then
        SubBlock(0) = BlockSize
        ReDim Preserve SubBlock(0 To BlockSize)
        Put hFile, , SubBlock
        BlockSize = 0
    End If
    Put hFile, , BlockSize 'ս
    
    
    'ȡģָ
    CopyMemory ByVal VarPtrArray(pByte), 0&, 4
    CopyMemory ByVal VarPtrArray(pBytePtr), 0&, 4
    
    
    #If DebugGIF Then
        Close hF
    #End If
    
    EncodeGIF_LZW = True
    Exit Function
    
InitStrTable:
    OldCode = LZW_CLEAR
    GoSub WriteCode
    CurBits = LZW_MinCodeLen + 1
    TableSize = LZW_EOI + 1
    TableMaxSize = 2 ^ CurBits
    Call ZeroMemory(NextNode(0), &H2000)
    Call ZeroMemory(SubNode(0), &H2000)
    Call ZeroMemory(StrAdd(0), &H1000)
Return

WriteCode:
    #If DebugGIF Then
        Print #hF, CStr(OldCode), CurBits
    #End If
    TempCode = TempCode Or OldCode * BitAndMask(LeftBits)
    LeftBits = LeftBits + CurBits
'    GoSub ShiftBit
'Return

ShiftBit:
    Do While LeftBits >= 8
        BlockSize = BlockSize + 1
        SubBlock(BlockSize) = TempCode And &HFF&
        '#If DebugGIF Then
        '    Print #hF, "Byte:" & Right$("0" & Hex(SubBlock(BlockSize)), 2) & "H"
        '#End If
        TempCode = TempCode \ &H100 'TempCode>>8
        LeftBits = LeftBits - 8
        If BlockSize = &HFF Then
            Put hFile, , SubBlock
            BlockSize = 0
        End If
    Loop
Return

End Function

'GIF_LZW
'hFile:ļľVBģ
'ImgInfo:GIFϢ
'gifsd:ҪһЩȫϢ
'lpBI:ָBitMapInfoHeaderָ
'lpBits:DIBλͼ
Public Function DecodeGIF_LZW(ByVal hFile As Integer, ByRef ImgInfo As gifimage, ByRef gifsd As gifscrdesc, ByVal lpBI As Long, ByRef lpBits() As Byte) As Boolean
    If m_Inited = False Then Init
    If lpBI = 0 Then Exit Function
    
    Dim I As Long
    
    'BitmapInfoݲ֧BITMAPV4HEADERBITMAPV5HEADER
    Dim BI As BITMAPINFO
    If IsBadReadPtr(ByVal lpBI, 4) Then Exit Function
    Call CopyMemory(I, ByVal lpBI, 4)
    Select Case I
    Case 40 'BITMAPINFOHEADER
    'Case 40 'BITMAPV4HEADER
    'Case 40 'BITMAPV5HEADER
    Case Else
        Exit Function
    End Select
    If IsBadReadPtr(ByVal lpBI, I) Then Exit Function
    CopyMemory BI, ByVal lpBI, Len(BI)
    
    'ȡͼϢ
    Dim DataBits As Long
    Dim LineBytes As Long
    Get hFile, , ImgInfo
    With ImgInfo
        'If .LocalFlag And LocalFlag_Interlace Then Exit Function
        If .LocalFlag And LocalFlag_LocalPal Then
            DataBits = (.LocalFlag And LocalFlag_PalBits) + 1
            If IsBadWritePtr(ByVal CLng(lpBI + BI.bmiHeader.biSize), (2 ^ DataBits) * 4) Then Exit Function
            For I = 0 To 2 ^ DataBits - 1
                Get hFile, , BI.bmiColors(I).rgbRed
                Get hFile, , BI.bmiColors(I).rgbGreen
                Get hFile, , BI.bmiColors(I).rgbBlue
            Next I
        Else
            DataBits = gifsd.GlobalFlag And GlobalFlag_PalBits
        End If
    End With
    With BI.bmiHeader
        .biWidth = ImgInfo.wWidth
        .biHeight = ImgInfo.wDepth
        .biPlanes = 1
        .biBitCount = 8
        .biCompression = BI_RGB
        LineBytes = ((.biWidth * .biBitCount + 31&) And &HFFFFFFE0) \ 8
        .biSizeImage = LineBytes * .biHeight
        ReDim lpBits(0 To .biSizeImage)
    End With
    CopyMemory ByVal lpBI, BI, Len(BI)
    
    Dim LZW_MinCodeLen As Byte
    Get hFile, , LZW_MinCodeLen
    
    
    'Debug.Print "ʽʼ"
    '== ʽʼ ============================
    Dim StrAdd(0 To &H1000) As Byte
    Dim Parent(0 To &H1000) As Integer
    Dim Level(0 To &H1000) As Integer
    Dim TableSize As Long
    Dim TableMaxSize As Long
    Dim TempBytes(0 To &H1000) As Byte
    Dim BytesCount As Long
    Dim CurBits As Long
    Dim LZW_CLEAR As Integer
    Dim LZW_EOI As Integer
    Dim OldCode As Integer
    Dim CurCode As Integer
    Dim TempIdx As Integer
    Dim TempCode As Long
    Dim LeftBits As Long
    Dim SubBlock() As Byte
    Dim BlockSize As Byte
    Dim BlockPos As Integer
    Dim byPass As Byte
    
    #If DebugGIF Then
        Dim CodeCount As Long
        Dim hF As Integer
        hF = FreeFile()
        Open "c:\DebugGIF_De.log" For Output As #hF
    #End If
    
    LZW_CLEAR = 2 ^ LZW_MinCodeLen 'DataBits
    LZW_EOI = LZW_CLEAR + 1
    CurBits = LZW_MinCodeLen + 1
    GoSub GetNextCode
    OldCode = CurCode
    'If CurCode <> LZW_CLEAR Then GoTo DecodeEnd
    'Do
    '    GoSub GetNextCode
    'Loop While CurCode = LZW_CLEAR
    'If CurCode >= LZW_EOI Then GoTo DecodeEnd
    GoSub InitStrTable
    
    byPass = 0
    Dim LinePtr As Long, CurPtr As Long
    Dim X As Long, Y As Long
    X = 0
    Y = 0
    LinePtr = VarPtr(lpBits(0)) + (BI.bmiHeader.biHeight - 1) * LineBytes 'DIB洢
    CurPtr = LinePtr
    Do
        If CurCode = LZW_CLEAR Then
            GoSub InitStrTable
            Do
                GoSub GetNextCode
            Loop While CurCode = LZW_CLEAR
            If CurCode >= LZW_EOI Then Debug.Print "," & Y: GoTo DecodeEnd
            TempBytes(0) = CurCode
            BytesCount = 1
        ElseIf CurCode = LZW_EOI Then
            Exit Do
        Else
            If OldCode = LZW_CLEAR Then Exit Function
            
            If TableSize > TableMaxSize Then
                Debug.Print ">"
                GoTo DecodeEnd
            End If
            
            TempIdx = IIf(CurCode < TableSize, CurCode, OldCode)
            BytesCount = Level(TempIdx)
            For I = 0 To BytesCount - 1
                TempBytes(BytesCount - I) = StrAdd(TempIdx)
                TempIdx = Parent(TempIdx)
            Next I
            TempBytes(0) = TempIdx
            BytesCount = BytesCount + 1
            If CurCode >= TableSize Then
                '= +GetFirstChar(Code2Str(OldCode))
                TempBytes(BytesCount) = TempBytes(0)
                BytesCount = BytesCount + 1
            End If
            StrAdd(TableSize) = TempBytes(0)
            Parent(TableSize) = OldCode
            Level(TableSize) = Level(OldCode) + 1
            TableSize = TableSize + 1
            If TableSize >= TableMaxSize Then
                If CurBits < MaxCodeBits Then
                    CurBits = CurBits + 1
                    TableMaxSize = TableMaxSize * 2
                End If
            End If
            
        End If
        OldCode = CurCode
        GoSub GetNextCode
        
        I = 0
        While I < BytesCount
            TempIdx = BI.bmiHeader.biWidth - X
            If BytesCount - I >= TempIdx Then
                CopyMemory ByVal CurPtr, TempBytes(I), TempIdx
                I = I + TempIdx
                If ImgInfo.LocalFlag And LocalFlag_Interlace Then
                    Y = Y + IncTable(byPass)
                    If Y >= BI.bmiHeader.biHeight Then
                        byPass = byPass + 1
                        Y = BgnTable(byPass)
                        If IncTable(byPass) = 0 Then Exit Do
                    End If
                    CurPtr = VarPtr(lpBits(0)) + (BI.bmiHeader.biHeight - 1 - Y) * LineBytes 'DIB洢
                Else
                    Y = Y + 1
                    If Y >= BI.bmiHeader.biHeight Then Exit Do
                    LinePtr = LinePtr - LineBytes
                    CurPtr = LinePtr
                End If
                X = 0
            Else
                TempIdx = BytesCount - I
                CopyMemory ByVal CurPtr, TempBytes(I), TempIdx
                I = I + TempIdx
                X = X + TempIdx
                CurPtr = CurPtr + TempIdx
                BytesCount = 0
            End If
        Wend
        BytesCount = 0
        
    Loop
    
    #If DebugGIF Then
        Close hF
    #End If
    
    'Debug.Print "End"
DecodeEnd:
    If BlockSize Then
        Get hFile, , BlockSize
        Do While BlockSize
            ReDim SubBlock(1 To BlockSize)
            Get hFile, , SubBlock
            Get hFile, , BlockSize
        Loop
    End If
    
    DecodeGIF_LZW = True
    Exit Function


InitStrTable:
    CurBits = LZW_MinCodeLen + 1
    TableSize = LZW_EOI + 1
    TableMaxSize = 2 ^ CurBits
    Call ZeroMemory(StrAdd(0), &H1000)
    Call ZeroMemory(Parent(0), &H2000)
    Call ZeroMemory(Level(0), &H2000)
Return


GetNextCode:
    Do While LeftBits < CurBits
        If (BlockPos > BlockSize) Or (BlockSize = 0) Then
            Get hFile, , BlockSize
            If BlockSize = 0 Then GoTo DecodeEnd
            ReDim SubBlock(1 To BlockSize)
            Get hFile, , SubBlock
            BlockPos = 1
        End If
        TempCode = TempCode Or (SubBlock(BlockPos) * BitAndMask(LeftBits)) 'TempCode |= SubBlock(BlockPos)<<LeftBits
        LeftBits = LeftBits + 8
        BlockPos = BlockPos + 1
    Loop
    CurCode = TempCode And BitsMask(CurBits)
    #If DebugGIF Then
        CodeCount = CodeCount + 1
        Print #hF, CurCode, CurBits
        'Print #hF, Format(CurCode, "0000") & ":" & Format(TableSize, "0000")
    #End If
    TempCode = TempCode \ BitAndMask(CurBits)
    LeftBits = LeftBits - CurBits
Return

End Function

Public Function LoadGIF_(ByRef FileName As String, ByRef lpBI As BITMAPINFO, ByRef MapData() As Byte) As Boolean
    Dim I As Long
    
    Dim hFile As Integer
    Dim gifh As gifheader
    Dim gifsd As gifscrdesc
    Dim gifi As gifimage
    Dim TempByte As Byte
    
    hFile = FreeFile
    
    On Error Resume Next
    Open FileName For Input As hFile
    If Err.Number Then Exit Function
    Close hFile
    On Error GoTo 0
    
    Open FileName For Binary Access Read Lock Write As hFile
    
    Get hFile, , gifh
    If StrConv(gifh.bySignature, vbUnicode) <> "GIF" Then Exit Function
    Select Case StrConv(gifh.byVersion, vbUnicode)
    Case "87a"
    Case "89a"
    Case Else
        Exit Function
    End Select
    
    Get hFile, , gifsd
    If gifsd.GlobalFlag And GlobalFlag_GlobalPal Then
        For I = 0 To 2 ^ ((gifsd.GlobalFlag And GlobalFlag_PalBits) + 1) - 1
            Get hFile, , lpBI.bmiColors(I).rgbRed
            Get hFile, , lpBI.bmiColors(I).rgbGreen
            Get hFile, , lpBI.bmiColors(I).rgbBlue
        Next I
    End If
    
    Dim ImgInfo As gifimage
    Dim SubBlock() As Byte
    Dim BlockSize As Byte
    Do
        Get hFile, , TempByte
        Select Case TempByte
        Case GIF_ImageSeparator
            If DecodeGIF_LZW(hFile, ImgInfo, gifsd, VarPtr(lpBI), MapData) Then
                Exit Do
            Else
                Exit Function
            End If
        Case GIF_Extension
            Get hFile, , TempByte
            Get hFile, , BlockSize
            Do While BlockSize
                ReDim SubBlock(1 To BlockSize)
                Get hFile, , SubBlock
                Get hFile, , BlockSize
            Loop
        Case Else
            Exit Function
        End Select
    Loop
    
    Close hFile
    
    LoadGIF_ = True
    
End Function

Public Function SaveGIF(ByRef Image As StdPicture, ByRef FileName As String) As Boolean
    If Image.Type <> VBRUN.PictureTypeConstants.vbPicTypeBitmap Then Exit Function
    
    Dim I As Long
    
    Dim bm As BITMAP
    If GetObject(Image.Handle, Len(bm), bm) = 0 Then Exit Function
    
    Dim BI As BITMAPINFO
    With BI.bmiHeader
        .biSize = Len(BI.bmiHeader)
        .biWidth = bm.bmWidth
        .biHeight = bm.bmHeight
        .biPlanes = bm.bmPlanes
        .biBitCount = bm.bmBitsPixel
        If .biBitCount > 8 Then .biBitCount = 8
        .biCompression = BI_RGB
        .biSizeImage = (((.biWidth * .biBitCount + 31&) And &HFFFFFFE0) \ 8) * .biHeight
        
        Dim MapData() As Byte
        ReDim MapData(0 To .biSizeImage)
        
    End With
    
    
'    Dim hDC As Long
'    Dim hOldMap As Long
'
'    hDC = CreateCompatibleDC(0)
'    If hDC = 0 Then Exit Function
'    hOldMap = SelectObject(hDC, Image.Handle)
'
'    I = GetDIBits(hDC, Image.Handle, 0, bm.bmHeight, MapData(0), BI, DIB_RGB_COLORS)
'
'    Call SelectObject(hDC, hOldMap)
'    Call DeleteDC(hDC)
    Dim IPic As IPicture
    Set IPic = Image
    I = GetDIBits(IPic.CurDC, Image.Handle, 0, bm.bmHeight, MapData(0), BI, DIB_RGB_COLORS)
    Set IPic = Nothing
    If I = 0 Then Exit Function
    
    
    '== ʼдļ ==============================
    Dim hFile As Integer
    Dim gifh As gifheader
    Dim gifsd As gifscrdesc
    Dim gifi As gifimage
    Dim TempByte As Byte
    
    hFile = FreeFile
    
    On Error Resume Next
    Open FileName For Output As hFile
    If Err.Number Then Exit Function
    Close hFile
    On Error GoTo 0
    
    Open FileName For Binary Access Write Lock Read Write As hFile
    
    gifh.bySignature(0) = AscB("G")
    gifh.bySignature(1) = AscB("I")
    gifh.bySignature(2) = AscB("F")
    gifh.byVersion(0) = AscB("8")
    gifh.byVersion(1) = AscB("7")
    gifh.byVersion(2) = AscB("a")
    Put hFile, , gifh
    
    gifsd.wWidth = bm.bmWidth
    gifsd.wDepth = bm.bmHeight
    gifsd.GlobalFlag = (BI.bmiHeader.biBitCount - 1) * &H11 Or GlobalFlag_GlobalPal
    gifsd.byBackground = 0
    gifsd.byAspect = 0
    Put hFile, , gifsd
    
    For I = 0 To (2 ^ BI.bmiHeader.biBitCount) - 1
        Put hFile, , BI.bmiColors(I).rgbRed
        Put hFile, , BI.bmiColors(I).rgbGreen
        Put hFile, , BI.bmiColors(I).rgbBlue
    Next I
    
    Put hFile, , GIF_ImageSeparator
    
    'gifi.LocalFlag = LocalFlag_LocalPal
    If EncodeGIF_LZW(VarPtr(BI), VarPtr(MapData(0)), hFile, gifi, gifsd) = False Then
        Close hFile
        Exit Function
    End If
    
    Put hFile, , Gif_Terminator
    
    Close hFile
    
    
    SaveGIF = True
    
End Function

Public Function LoadGIF(ByRef FileName As String, ByVal Pic As PictureBox) As Boolean
    Dim BI As BITMAPINFO
    Dim MapData() As Byte
    
    BI.bmiHeader.biSize = Len(BI.bmiHeader)
    If LoadGIF_(FileName, BI, MapData) = False Then Exit Function
    
    Dim P As Object
    Set P = Pic.Container
    
    Dim OldSM As Long
    Dim OldB As Long
    
    If Not P Is Nothing Then
        OldSM = P.ScaleMode
        P.ScaleMode = vbPixels
    End If
    OldB = Pic.BorderStyle
    Pic.BorderStyle = 0
    Pic.AutoRedraw = True
    Pic.Move Pic.Left, Pic.Top, BI.bmiHeader.biWidth, BI.bmiHeader.biHeight
    Call SetDIBitsToDevice(Pic.hDC, 0, 0, BI.bmiHeader.biWidth, BI.bmiHeader.biHeight, 0, 0, 0, BI.bmiHeader.biHeight, MapData(0), BI, DIB_RGB_COLORS)
    Pic.BorderStyle = OldB
    If Not P Is Nothing Then
        P.ScaleMode = OldSM
    End If
    Pic.Refresh
    
    LoadGIF = True
    
End Function

